Loading...
Searching...
No Matches
Dune::SeqSOR< M, X, Y, l > Class Template Reference
Iterative Solvers Template Library (ISTL) » Iterative Solvers » Preconditioners

Sequential SOR preconditioner. More...

`#include <dune/istl/preconditioners.hh>`

Inheritance diagram for Dune::SeqSOR< M, X, Y, l >:

## Public Types

typedef M | matrix_type
| The matrix type the preconditioner is for.
typedef X | domain_type
| The domain type of the preconditioner.
typedef Y | range_type
| The range type of the preconditioner.
typedef X::field_type | field_type
| The field type of the preconditioner.
typedef Simd::Scalar< field_type > | scalar_field_type
| scalar type underlying the field_type
typedef FieldTraits< scalar_field_type >::real_type | real_field_type
| real scalar type underlying the field_type

## Public Member Functions

| SeqSOR (const M &A, int n, real_field_type w)
| Constructor.
| SeqSOR (const std::shared_ptr< const AssembledLinearOperator< M, X, Y > > &A, const ParameterTree &configuration)
| Constructor.
| SeqSOR (const M &A, const ParameterTree &configuration)
| Constructor.
void | pre (X &x, Y &b) override
| Prepare the preconditioner.
void | apply (X &v, const Y &d) override
| Apply the preconditioner.
template<bool forward>
void | apply (X &v, const Y &d)
| Apply the preconditioner in a special direction.
void | post (X &x) override
| Clean up.
SolverCategory::Category | category () const override
| Category of the preconditioner (see SolverCategory::Category).

## Detailed Description

template<class M, class X, class Y, int l = 1>
class Dune::SeqSOR< M, X, Y, l >

Sequential SOR preconditioner.

Wraps the naked ISTL generic SOR preconditioner into the solver framework.

Template Parameters

  M | The matrix type to operate on
  X | Type of the update
  Y | Type of the defect
  l | The block level to invert. Default is 1

## Member Typedef Documentation

## domain_type

template<class M, class X, class Y, int l = 1>

typedef X Dune::SeqSOR< M, X, Y, l >::domain_type

The domain type of the preconditioner.

## field_type

template<class M, class X, class Y, int l = 1>

typedef X::field_type Dune::SeqSOR< M, X, Y, l >::field_type

The field type of the preconditioner.

## matrix_type

template<class M, class X, class Y, int l = 1>

typedef M Dune::SeqSOR< M, X, Y, l >::matrix_type

The matrix type the preconditioner is for.

## range_type

template<class M, class X, class Y, int l = 1>

typedef Y Dune::SeqSOR< M, X, Y, l >::range_type

The range type of the preconditioner.

## real_field_type

template<class M, class X, class Y, int l = 1>

typedef FieldTraits<scalar_field_type>::real_type Dune::SeqSOR< M, X, Y, l >::real_field_type

real scalar type underlying the field_type

## scalar_field_type

template<class M, class X, class Y, int l = 1>

typedef Simd::Scalar<field_type> Dune::SeqSOR< M, X, Y, l >::scalar_field_type

scalar type underlying the field_type

## Constructor & Destructor Documentation

## SeqSOR() [1/3]

template<class M, class X, class Y, int l = 1>

Dune::SeqSOR< M, X, Y, l >::SeqSOR | ( | const M & | A,
|  | int | n,
|  | real_field_type | w )

inline

Constructor.

constructor gets all parameters to operate the prec.

Parameters

  A | The matrix to operate on.
  n | The number of iterations to perform.
  w | The relaxation factor.

## SeqSOR() [2/3]

template<class M, class X, class Y, int l = 1>

Dune::SeqSOR< M, X, Y, l >::SeqSOR | ( | const std::shared_ptr< const AssembledLinearOperator< M, X, Y > > & | A,
|  | const ParameterTree & | configuration )

inline

Constructor.

Parameters

  A | The assembled linear operator to use.
  configuration | ParameterTree containing preconditioner parameters.

ParameterTree Key | Meaning
--- | ---
iterations | The number of iterations to perform. default=1
relaxation | The relaxation factor. default=1.0

See ISTL_Factory for the ParameterTree layout and examples.

## SeqSOR() [3/3]

template<class M, class X, class Y, int l = 1>

Dune::SeqSOR< M, X, Y, l >::SeqSOR | ( | const M & | A,
|  | const ParameterTree & | configuration )

inline

Constructor.

Parameters

  A | The matrix to operate on.
  configuration | ParameterTree containing preconditioner parameters.

ParameterTree Key | Meaning
--- | ---
iterations | The number of iterations to perform. default=1
relaxation | The relaxation factor. default=1.0

See ISTL_Factory for the ParameterTree layout and examples.

## Member Function Documentation

## apply() [1/2]

template<class M, class X, class Y, int l = 1>
template<bool forward>

void Dune::SeqSOR< M, X, Y, l >::apply | ( | X & | v,
|  | const Y & | d )

inline virtual

Apply the preconditioner in a special direction.

The template parameter forward indications the direction the smoother is applied. If true The application is started at the lowest index in the vector v, if false at the highest index of vector v.

Implements Dune::Preconditioner< X, Y >.

## apply() [2/2]

template<class M, class X, class Y, int l = 1>

void Dune::SeqSOR< M, X, Y, l >::apply | ( | X & | v,
|  | const Y & | d )

inline override virtual

Apply the preconditioner.

Apply one step of the preconditioner to the system A(v)=d.

On entry v=0 and d=b-A(x) (although this might not be computed in that way. On exit v contains the update, i.e one step computes where is the approximate inverse of the operator characterizing the preconditioner.

Parameters

  [out] | v | The update to be computed
  | d | The current defect.

Implements Dune::Preconditioner< X, Y >.

## category()

template<class M, class X, class Y, int l = 1>

SolverCategory::Category Dune::SeqSOR< M, X, Y, l >::category | ( |  | ) | const

inline override virtual

Category of the preconditioner (see SolverCategory::Category).

Implements Dune::Preconditioner< X, Y >.

## post()

template<class M, class X, class Y, int l = 1>

void Dune::SeqSOR< M, X, Y, l >::post | ( | X & | x | ) |

inline override virtual

Clean up.

Clean up.

This method is called after the last apply call for the linear system to be solved. Memory may be deallocated safely here. x is the solution of the linear equation.

Parameters

  x | The right hand side of the equation.

Implements Dune::Preconditioner< X, Y >.

## pre()

template<class M, class X, class Y, int l = 1>

void Dune::SeqSOR< M, X, Y, l >::pre | ( | X & | x,
|  | Y & | b )

inline override virtual

Prepare the preconditioner.

Prepare the preconditioner.

A solver solves a linear operator equation A(x)=b by applying one or several steps of the preconditioner. The method pre() is called before the first apply operation. b and x are right hand side and solution vector of the linear system respectively. It may. e.g., scale the system, allocate memory or compute a (I)LU decomposition. Note: The ILU decomposition could also be computed in the constructor or with a separate method of the derived method if several linear systems with the same matrix are to be solved.

Note
  if a preconditioner is copied (e.g. for a second thread) again the pre() method has to be called to ensure proper memory management.

X x(0.0);
Y b = ...; // rhs
Preconditioner<X,Y> prec(...);
prec.pre(x,b); // prepare the preconditioner
prec.apply(x,b); // can be called multiple times now...
prec.post(x); // cleanup internal state
Dune::Preconditioner
Base class for matrix free definition of preconditioners.
Definition preconditioner.hh:33

Parameters

  x | The left hand side of the equation.
  b | The right hand side of the equation.

Implements Dune::Preconditioner< X, Y >.

The documentation for this class was generated from the following file:

- preconditioners.hh